# Class MrtTableBuilder

java.lang.Object
uk.ac.starlink.table.formats.DocumentedTableBuilder
uk.ac.starlink.table.formats.MrtTableBuilder

All Implemented Interfaces:
  `Documented, DocumentedIOHandler, TableBuilder`

public class MrtTableBuilder extends DocumentedTableBuilder
Input handler for the so-called "Machine-Readable Table" format used by AAS journals. This is a horrid format, based on the VizieR readMe files, which are themselves underdocumented, but picking and leaving whatever bits and pieces they feel like, without any careful documentation of that process. This reader has mainly been put together by looking at given instances of files claimed to be in this format.

Since:
  30 Apr 2021
Author:
  Mark Taylor
See Also:
  - https://journals.aas.org/mrt-standards/

## Field Summary

Fields
Modifier and Type
Field
Description
`static final String`
`MAGIC_TXT`
Should be present at the start of all MRT files.

## Constructor Summary

Constructors
Constructor
Description
`MrtTableBuilder()`
Default constructor.
`MrtTableBuilder(ErrorMode errorMode, boolean checkMagic, boolean useFloat)`
Constructor with configuration options.

## Method Summary

Modifier and Type
Method
Description
`boolean`
`canImport(DataFlavor flavor)`
Indicates whether this builder is able to turn a resource of media type indicated by `flavor` into a table.
`boolean`
`canStream()`
Indicates whether this handler can read tables from a stream.
`boolean`
`docIncludesExample()`
Indicates whether the serialization of some (short) example table should be added to the user documentation for this handler.
`boolean`
`getCheckMagic()`
Indicates whether the handler will attempt to guess by looking at the file whether it is an MRT file.
`ErrorMode`
`getErrorMode()`
Returns the error handling mode.
`String`
`getFormatName()`
Returns "MRT".
`boolean`
`getUseFloat()`
Indicates whether this handler will attempt to use 32-bit float columns for narrow floating point fields.
`String`
`getXmlDescription()`
Returns user-directed documentation in XML format.
`static boolean`
`isMagic(byte[] intro)`
Indicates whether the given buffer starts with the MRT magic number `"Title: "`.
`StarTable`
`makeStarTable(uk.ac.starlink.util.DataSource datsrc, boolean wantRandom, StoragePolicy storage)`
Constructs a `StarTable` based on a given `DataSource`.
`void`
`setCheckMagic(boolean checkMagic)`
Sets whether the handler will attempt to guess by looking at the file whether it appears to be an MRT file before attempting to parse it as one.
`void`
`setErrorMode(ErrorMode errorMode)`
Sets the error handling mode.
`void`
`setUseFloat(boolean useFloat)`
Sets whether this handler will use a 32-bit float type for reading sufficiently narrow floating point fields.
`void`
`streamStarTable(InputStream in, TableSink sink, String pos)`
Reads a table from an input stream and writes it a row at a time to a sink.

### Methods inherited from class DocumentedTableBuilder

`getExtensions, looksLikeFile`

### Methods inherited from class Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Methods inherited from interface DocumentedIOHandler

`readText`

## Field Details

### MAGIC_TXT

public static final String MAGIC_TXT
Should be present at the start of all MRT files.

See Also:
  - Constant Field Values

## Constructor Details

### MrtTableBuilder

public MrtTableBuilder()
Default constructor.

### MrtTableBuilder

public MrtTableBuilder(ErrorMode errorMode, boolean checkMagic, boolean useFloat)
Constructor with configuration options.

Parameters:
  `errorMode` - error handling mode
  `checkMagic` - whether to require finding the magic number before attempting to parse
  `useFloat` - true to attempt use of single-precision floating point values where it looks like they should be appropriate

## Method Details

### getFormatName

public String getFormatName()
Returns "MRT".

Returns:
  one-word description of this handler's format

### canImport

public boolean canImport(DataFlavor flavor)
Description copied from interface: `TableBuilder`
Indicates whether this builder is able to turn a resource of media type indicated by `flavor` into a table. It should return `true` if it thinks that its `TableBuilder.streamStarTable(InputStream, TableSink, String)` method stands a reasonable chance of successfully constructing a `StarTable` from a `DataSource` whose input stream is described by the `DataFlavor` `flavor`. It will typically make this determination based on the flavor's MIME type.

This method should only return `true` if the flavor looks like it is targeted at this builder; for instance a builder which uses a text-based format should return false for a flavor which indicates a MIME type of `text/plain`.

This method is used in supporting drag and drop functionality (see `StarTableFactory.canImport(java.awt.datatransfer.DataFlavor[])`).

Parameters:
  `flavor` - the DataFlavor whose suitability as stream input is to be assessed
Returns:
  `true` iff this builder reckons it stands a good chance of turning a stream of type `flavor` into a `StarTable`

### setErrorMode

@ConfigMethod(property="errmode", doc="<p>Indicates what action should be taken if formatting errors\nare detected in the file at read time.\n</p>", example="FAIL") public void setErrorMode(ErrorMode errorMode)
Sets the error handling mode.

Parameters:
  `errorMode` - error handling mode

### getErrorMode

public ErrorMode getErrorMode()
Returns the error handling mode.

Returns:
  error handling mode

### setCheckMagic

@ConfigMethod(property="checkmagic", doc="<p>Determines whether an initial test is made to see whether\nthe file looks like MRT before attempting to read it as one;\nthe test is that it starts with the string\n\"<code>Title: </code>\".\nSetting this true is generally a good idea\nto avoid attempting to parse non-MRT files,\nbut you can set it false to attempt to read an MRT file\nthat starts with the wrong sequence.\n</p>", example="false") public void setCheckMagic(boolean checkMagic)
Sets whether the handler will attempt to guess by looking at the file whether it appears to be an MRT file before attempting to parse it as one. This is generally a good idea, since otherwise it will attempt to make MRT sense of any old file, but you can set it false to try to parse MRT files with unexpected first few bytes.

Parameters:
  `checkMagic` - true to require magic number presence

### getCheckMagic

public boolean getCheckMagic()
Indicates whether the handler will attempt to guess by looking at the file whether it is an MRT file.

Returns:
  check magic flag

### setUseFloat

@ConfigMethod(property="usefloat", doc="<p>Sets whether this handler will use a 32-bit float type\nfor reading sufficiently narrow floating point fields.\nThis is usually a good idea\nsince it reduces storage requirements\nwhen only a few significant figures are provided,\nbut can fail if the column contains any\nvery large absolute values (&gt;~1e38),\nwhich cannot be represented in a 32-bit IEEE float.\nSo it's safer to set it false.\n</p>\n<p>If it is set true,\nthen encountering values outside the representable range\nwill be reported in accordance with the current ErrorMode.\n</p>", example="true") public void setUseFloat(boolean useFloat)
Sets whether this handler will use a 32-bit float type for reading sufficiently narrow floating point fields. This is usually a good idea since it reduces storage requirements when only a few significant figures are provided, but can fail if the column contains any very large absolute values (>~1e38), which cannot be represented in a float. So it's safer to set it false.

If it is set true, then encountering values outside the representable range will be reported in accordance with the current ErrorMode.

Parameters:
  `useFloat` - true to sometimes use 32-bit floats where it looks like a good idea, false to always use 64-bit doubles

### getUseFloat

public boolean getUseFloat()
Indicates whether this handler will attempt to use 32-bit float columns for narrow floating point fields.

Returns:
  true to sometimes use 32-bit floats, false to always use 64-bit doubles

### makeStarTable

public StarTable makeStarTable(uk.ac.starlink.util.DataSource datsrc, boolean wantRandom, StoragePolicy storage) throws IOException
Description copied from interface: `TableBuilder`
Constructs a `StarTable` based on a given `DataSource`. If the source is not recognised or this builder does not know how to construct a table from it, then a `TableFormatException` should be thrown. If this builder thinks it should be able to handle the source but an error occurs during processing, an `IOException` can be thrown.

The `wantRandom` parameter is used to indicate whether, ideally, a random-access table should be returned. There is no requirement for the builder to honour this request, but if it knows how to make both random and non-random tables, it can use this flag to decide which to return.

Note: the presence of the `wantRandom` parameter is somewhat misleading. TableBuilder implementations usually should, and do, ignore it (it would be removed from the interface if it were not for backward compatibility issues). Regardless of the value of this parameter, implementations should return a random-access table only if it is easy for them to do so; in particular they should not use the supplied `storagePolicy`, or any other resource-expensive measure, to randomise a sequential table just because the `wantRandom` parameter is true.

Parameters:
  `datsrc` - the DataSource containing the table resource
  `wantRandom` - whether, preferentially, a random access table should be returned
  `storage` - a StoragePolicy object which may be used to supply scratch storage if the builder needs it
Returns:
  a StarTable made out of `datsrc`
Throws:
  `IOException` - if an unexpected I/O error occurs during processing

### streamStarTable

public void streamStarTable(InputStream in, TableSink sink, String pos) throws IOException
Description copied from interface: `TableBuilder`
Reads a table from an input stream and writes it a row at a time to a sink. Not all implementations will be able to do this; for instance, extracting the table from the data may be a two-pass process. Implementations which are unable to perform this function should throw a `TableFormatException`.

The input stream should be prepared for use prior to calling this method, so implementations should not in general attempt to decompress or buffer `istrm`.

Parameters:
  `in` - input stream containing table data
  `sink` - destination of the table
  `pos` - position identifier describing the location of the table within the stream; see `DataSource.getPosition()` (may be null)
Throws:
  `IOException` - if some other error occurs

### canStream

public boolean canStream()
Description copied from class: `DocumentedTableBuilder`
Indicates whether this handler can read tables from a stream.

Specified by:
  `canStream` in class `DocumentedTableBuilder`
Returns:
  true iff this handler can read from streams

### docIncludesExample

public boolean docIncludesExample()
Description copied from interface: `DocumentedIOHandler`
Indicates whether the serialization of some (short) example table should be added to the user documentation for this handler. Binary formats, or instances for which the `Documented.getXmlDescription()` method already includes some example output, should return false.

Returns:
  true if the user documentation would benefit from the addition of an example serialization

### getXmlDescription

public String getXmlDescription()
Description copied from interface: `Documented`
Returns user-directed documentation in XML format.

The output should be a sequence of one or more <P> elements, using XHTML-like XML. Since rendering may be done in a number of contexts however, use of the full range of XHTML elements is discouraged. Where possible, the content should stick to simple markup such as the elements P, A, UL, OL, LI, DL, DT, DD EM, STRONG, I, B, CODE, TT, PRE.

Returns:
  XML description of this object

### isMagic

public static boolean isMagic(byte[] intro)
Indicates whether the given buffer starts with the MRT magic number `"Title: "`.

Parameters:
  `intro` - byte buffer
Returns:
  true iff magic number is present